﻿
Imports System.ComponentModel
Imports System.Runtime.CompilerServices
Imports System.Collections.ObjectModel

Public Class c_myList(Of T)
    Inherits List(Of T) 'eigene list/collection um item.add überschreiben zu können. damit click weiterleitung gesetzt wird
    Implements INotifyPropertyChanged

    Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub
    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Private _Name As String
    Public Property Name As String
        Get
            Return _Name
        End Get
        Set(value As String)
            _Name = value
            RaisePropertyChanged()
        End Set
    End Property

#Region "items"
    Dim _Item As New List(Of T)
    Public Overloads Property Item As List(Of T)
        Get
            Return _Item
        End Get

        Set(value As List(Of T))
            _Item = value
            For Each i In value
                addHandler_nachType(i)
            Next

            RaisePropertyChanged()
        End Set
    End Property
    Public Overloads Function Add(i As T)   'Grund warum eigene collection gemacht wird 
        Item.Add(i)
        addHandler_nachType(i)
        Return True
    End Function
    Public Overloads Function AddRange(i As List(Of T))   'Grund warum eigene collection gemacht wird 
        For Each j In i
            Item.Add(j)
            addHandler_nachType(j)
        Next
        Return True
    End Function
#End Region

#Region "click routing "
    Public Sub addHandler_nachType(i As T)
        'item typ feststellen und entsprechende handler anlegen
        If TypeOf i Is c1_Person Then
            addC1Click(i)
        ElseIf TypeOf i Is c2_Gruppe Then
            addC2Click(i)
        ElseIf TypeOf i Is c3_Sammler Then
            addC3Click(i)
        End If
    End Sub
    Private Sub addC1Click(i As T)
        Dim a As c1_Person
        a = TryCast(i, c1_Person)
        AddHandler a.eventClickPerson, AddressOf Me.event_C2Click
    End Sub
    Private Sub addC2Click(i As T)
        Dim a As c2_Gruppe
        a = TryCast(i, c2_Gruppe)
        AddHandler a.PersClick, AddressOf Me.event_C2Click
    End Sub
    Private Sub addC3Click(i As T)
        Dim a As c3_Sammler
        a = TryCast(i, c3_Sammler)
        AddHandler a.PersClick, AddressOf Me.event_C2Click
    End Sub

#End Region

#Region "click work"
    Public Event PersClick(ByRef p As c1_Person)

    Public Sub event_C2Click(ByRef p As c1_Person)
        RaiseEvent PersClick(p)
    End Sub

#End Region

End Class

